## ros-iron-pick-ik 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(pick_ik)

if(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
    add_compile_options(-Wall -Wextra -Wpedantic -Wshadow -Wconversion -Wsign-conversion -Wold-style-cast)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)

find_package(fmt REQUIRED)
find_package(generate_parameter_library REQUIRED)
find_package(moveit_core REQUIRED)
find_package(pluginlib REQUIRED)
find_package(range-v3 REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rsl REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_kdl REQUIRED)
find_package(tl_expected REQUIRED)

generate_parameter_library(
  pick_ik_parameters
  src/pick_ik_parameters.yaml
)
add_library(pick_ik_plugin SHARED
  src/fk_moveit.cpp
  src/forward_kinematics.cpp
  src/pick_ik_plugin.cpp
  src/goal.cpp
  src/ik_memetic.cpp
  src/ik_gradient.cpp
  src/robot.cpp
)
target_compile_features(pick_ik_plugin PUBLIC c_std_99 cxx_std_17)
target_include_directories(pick_ik_plugin PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include/pick_ik>)
target_link_libraries(pick_ik_plugin
  PUBLIC
    moveit_core::moveit_robot_model
    tf2_geometry_msgs::tf2_geometry_msgs
    tf2_kdl::tf2_kdl
    tl_expected::tl_expected
    rsl::rsl
  PRIVATE
    fmt::fmt
    pick_ik_parameters
    moveit_core::moveit_kinematics_base
    moveit_core::moveit_robot_state
    pluginlib::pluginlib
    range-v3::range-v3
    rclcpp::rclcpp
)

pluginlib_export_plugin_description_file(
  moveit_core
  pick_ik_kinematics_description.xml
)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

install(
  DIRECTORY include/
  DESTINATION include/pick_ik
)
install(
  TARGETS pick_ik_plugin pick_ik_parameters
  EXPORT export_pick_ik
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_export_targets(export_pick_ik HAS_LIBRARY_TARGET)
ament_export_dependencies(
  fmt
  moveit_core
  pluginlib
  range-v3
  rclcpp
  rsl
  tf2_geometry_msgs
  tf2_kdl
  tl_expected
)
ament_package()

=== tests/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

find_package(Catch2 3.3.0 REQUIRED)

add_executable(test-pick_ik
    goal_tests.cpp
    ik_tests.cpp
    ik_memetic_tests.cpp
    robot_tests.cpp
)
target_link_libraries(test-pick_ik
        PRIVATE
    pick_ik_plugin
    Catch2::Catch2WithMain
    moveit_core::moveit_test_utils
)
catch_discover_tests(test-pick_ik)

=== debian/changelog ===
ros-iron-pick-ik (1.0.1-2jammy) jammy; urgency=high

  * Set Werror through CMake presets (#39 <https://github.com/PickNikRobotics/pick_ik/issues/39>)
  * Replace lower_bounds with gt_eq (#37 <https://github.com/PickNikRobotics/pick_ik/issues/37>)
  * Upgrade with new pkgs to fix issue with ROS
  * Target include subdirectory
  * Update Catch2 version to 3.3.0
  * Fix overriding of package
  * Fix orientation calculation in cost function and frame tests (#31 <https://github.com/PickNikRobotics/pick_ik/issues/31>)
    * Fix orientation calculation
    * Update plugin return values
    * Remove redundant (and incorrect) joints bounds check
    * Use Eigen angular distance calculation
  * Small grammar fixes (#28 <https://github.com/PickNikRobotics/pick_ik/issues/28>)
  * Contributors: Sebastian Castro, Stephanie Eng, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Mon, 27 Mar 2023 16:00:00 -0000

ros-iron-pick-ik (1.0.0-2jammy) jammy; urgency=high

  * pick_ik inverse kinematics plugin compatible with MoveIt 2
  * Numeric gradient descent (local) solver
  * Memetic algorithm (global solver), configurable for single or multi-threading
  * Basic goal functions: joint centering, avoid joint limits, minimal joint displacement
  * Support for position-only IK and approximate solutions
  * Dynamic parameter switching at runtime using generate_parameter_library <https://github.com/PickNikRobotics/generate_parameter_library>
  * Docker devcontainer workflow for VSCode
  * Contributors: Chris Thrasher, Sebastian Castro, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Wed, 07 Dec 2022 16:00:00 -0000

=== debian/control ===
Source: ros-iron-pick-ik
Section: misc
Priority: optional
Maintainer: Tyler Weaver <maybe@tylerjw.dev>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, librange-v3-dev, ros-iron-ament-cmake-ros, ros-iron-generate-parameter-library, ros-iron-moveit-core, ros-iron-moveit-resources-panda-moveit-config <!nocheck>, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rsl, ros-iron-tf2-geometry-msgs, ros-iron-tf2-kdl, ros-iron-tl-expected, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-pick-ik
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, librange-v3-dev, ros-iron-generate-parameter-library, ros-iron-moveit-core, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rsl, ros-iron-tf2-geometry-msgs, ros-iron-tf2-kdl, ros-iron-tl-expected, ros-iron-ros-workspace
Description: Inverse Kinematics solver for MoveIt

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-pick-ik//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
